package eu.mhsl.minenet.minigames.instance.game.stateless.types.towerdefense;

import net.minestom.server.entity.EntityCreature;
import net.minestom.server.entity.EntityType;
import net.minestom.server.entity.attribute.Attribute;

record EnemyFactory(EntityType entityType, float health, double speed) {
    public EnemyFactory(EntityType entityType) {
        this(entityType, 20, 0.3);
    }

    public EntityCreature buildEntity() {
        EntityCreature entity = new EntityCreature(this.entityType);
        entity.getAttribute(Attribute.MOVEMENT_SPEED).setBaseValue(this.speed);
        entity.setHealth(this.health);
        return entity;
    }
}
